varying mediump vec2 v_texCoord;
varying mediump vec4 v_waveCoord;
varying mediump vec4 v_waveCoord2;

uniform sampler2D u_normalTexture;
uniform sampler2D u_causticTexture;

void main()
{
    lowp vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    lowp vec4 normColor1 = texture2D(u_normalTexture, v_waveCoord.xy);
    lowp vec4 normColor2 = texture2D(u_normalTexture, v_waveCoord.zw);
    lowp vec4 causticColor1 = texture2D(u_causticTexture, v_waveCoord2.xy);
    lowp vec4 causticColor2 = texture2D(u_causticTexture, v_waveCoord2.zw);

    lowp float alpha1 = normColor1.r * normColor2.r;
    lowp float alpha2 = causticColor1.r * causticColor2.r;

    lowp float alpha = (0.2 + alpha1 * 0.4) * alpha1 + (0.4 + alpha2 * 0.5) * alpha2;
    gl_FragColor = vec4(texColor.rgb, alpha * texColor.a);
}