attribute vec4 a_position;
attribute vec2 a_texCoord;

uniform mediump vec4 u_waveOffset;
uniform mediump vec4 u_waveMat1;
uniform mediump vec4 u_waveMat2;
uniform mediump vec4 u_texScale;
uniform mediump vec4 u_causticOffset;
uniform mediump vec4 u_causticScale;
uniform mediump vec4 u_maskTexCoord;


varying mediump vec4 v_texWave;
varying mediump vec4 v_texCaustic;
varying mediump vec4 v_eyeDir;
varying mediump vec2 v_maskTexCoord;

void main(void)
{
    gl_Position = CC_PMatrix * a_position;

    v_texWave.x = dot(a_texCoord.xy, u_waveMat1.xy);
    v_texWave.y = dot(a_texCoord.xy, u_waveMat1.zw);
    v_texWave.z = dot(a_texCoord.xy, u_waveMat2.xy);
    v_texWave.w = dot(a_texCoord.xy, u_waveMat2.zw);
    v_texWave += u_waveOffset;

    v_texCaustic = a_texCoord.xyxy * u_causticScale + u_causticOffset;
    vec3 eyePos = vec3(0, -0.5, 0.3);
    vec2 worldPos = gl_Position.xy / gl_Position.w;
    worldPos.y *= 960.0 / 640.0;
    v_eyeDir.xyz = normalize(eyePos - vec3(worldPos, 0.0));
    v_eyeDir.w = min(1.0, mix(1.2, 0.6, (worldPos.y + 1.0) * 0.5));
    v_maskTexCoord = a_texCoord.xy * u_maskTexCoord.zw + u_maskTexCoord.xy;
}

