varying highp vec4 v_texWave;

varying mediump vec4 v_texCaustic;
varying mediump vec4 v_eyeDir;
varying mediump vec2 v_maskTexCoord;

uniform sampler2D u_maskTexture;
uniform sampler2D u_causticTexture;

vec3 decodeNormal(vec4 tex, float scale)
{
    mediump vec3 norm = tex.rgb * 2.0 - 1.0;
    norm.z *= scale;
    return norm;
}


void main()
{
    vec4 maskColor = texture2D(u_maskTexture, v_maskTexCoord.xy);
    float alpha = smoothstep(0.9, 0.0, maskColor.r);
    if (alpha <= 0.0)
        discard;

    vec3 waterColor = vec3(0.01, 0.46, 0.6) * v_eyeDir.w;

    vec3 edgeColor = vec3(0.6, 1.0, 0.8);
    vec3 color = waterColor + edgeColor * maskColor.r;

    gl_FragColor = vec4(color, alpha);
}